package com.sd.business.service.inventory;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.service.BaseService;
import com.sd.business.entity.inventory.dto.InventoryFinishedSelectDto;
import com.sd.business.entity.inventory.po.InventoryFinished;
import com.sd.business.entity.inventory.vo.InventoryFinishedVo;
import com.sd.business.entity.order.po.OrderSku;

import java.util.List;


/**
 * <p>
 * 成品仓库 服务类
 * </p>
 *
 * @author
 * @since 2023-10-10
 */
public interface InventoryFinishedService extends BaseService<InventoryFinished> {

    /**
     * 成品仓库分页
     */
    Page<InventoryFinishedVo> getPage(InventoryFinishedSelectDto dto);

    /**
     * 生产入库
     *
     * @param orderIdList 订单id列表
     */
    void productionWarehousing(List<Long> orderIdList);

    /**
     * 删除订单回滚库存
     *
     * @param orderId 订单id
     */
    void removeOrder(Long orderId);

    /**
     * 销售出库
     *
     * @param orderIdList 订单id列表
     */
    void saleOutOfWarehouse(List<Long> orderIdList);

    /**
     * 成品仓出入库excel导出
     */
    void excelExport(InventoryFinishedSelectDto dto);

    /**
     * 锁定无源成品库存
     */
    boolean lockNoSourceStorage(List<? extends OrderSku> orderSkuList);

    /**
     * 解锁无源成品库存
     */
    void unlockNoSourceStorage(List<OrderSku> orderSkuList);

    /**
     * 无源成品销售出库
     * @param orderIdList
     */
    void noSourceSaleOutOfWarehouse(List<Long> orderIdList);

    /**
     * 无源成品入库
     */
    void noSourceInWarehousing(List<OrderSku> orderSkuList);
}
